// FANGS "OF System V1.0" t@CovO

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <direct.h>

#include "d88.h"

static unsigned char dir[0x400 * 3];			// Directory (512 x 7sector)
static unsigned char fat[0x400];				// FAT
static unsigned char buff[0x400*5*80];			// 1024byte x 5sector x 80track
char dirpath[FILENAME_MAX];						// 쐬fBNg

int main(int argc, char *argv[])
{
	int mode=1;
	if (argc==3 && !strcmp(argv[2],"-d"))
	{
		mode=0;
	}
	else if (argc!=2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		fprintf(stderr, "       -d : not make sub directory\n");
		return 1;
	}

	D88 disk;
	FILE *fp;

	// t@CJG[ɂȂ
	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();	// fBXNC[W

	for (int diskno = 0; diskno < numdisk; diskno++) {	// C[W̏

		disk.SelectDisk(diskno);
		sprintf(dirpath,"%03d",diskno);	// fBNg̐
		if (mode)
		{
			_mkdir(dirpath);				// fBNg쐬
			_chdir(dirpath);				//
			printf("\n[%s] -> %s\n",disk.GetDiskName(),dirpath);
		}
		else printf("\n[%s]\n",disk.GetDiskName());

		disk.SetRecordRange(0x01,0x05);
		disk.ReadDATA(0x25, 0x12, 0x01, 0x01, 0x03, dir, 0x400*3);	// fBNgǂݍ
		disk.ReadDATA(0x25, 0x12, 0x01, 0x04, 0x03, fat, 0x400);	// FATǂݍ

		// Track 1ȍ~fBXNC[WۂƓǂݍ
		disk.ReadDATA(0x01, 0x00, 0x01, 0x01, 0x03, &buff[0x400*5], 0x400*5*79);

		// t@C̐؂o
		for (int fn = 0; fn < 0xc0; fn++) {
			unsigned char *ent = &dir[fn * 0x10];		// fBNgGg|C^`

			if (ent[0] == 0x00) break;		// fBNg̍Ō

			char fname[FILENAME_MAX];				// t@C

			int i;
			int attr,crs,addr,filesize,writesize;

			int fnp = 0;
			for (i = 0; i < 6; i++)
			{
				char c = ent[i+1];		// t@CPo
				if (c==' ') break;
				fname[fnp++] = c;		// t@C\
			}
			if (ent[8] != ' ')			// gqKvȂt
			{
				fname[fnp++] = '.';
			}
			for (i = 6; i < 9; i++)	// 悤Ɋgqo
			{
				char c = ent[i+1];
				if (c==' ') break;
				fname[fnp++] = c;
			}
			fname[fnp++] = '\0';		// ̍Ō
			char atc[] = "SNV";			// \p

			attr  = ent[0x00]-1;	// 
			crs   = ent[0x0a]+ent[0x0b]*0x100;			// JnNX^
			addr  = ent[0x0c]+ent[0x0d]*0x100;			// [hAhX
			filesize  = ent[0x0e]+ent[0x0f]*0x100;		// t@CTCY
			printf("%c  %-10s  %5d  ADDR=%04x\n",atc[attr],fname,filesize,addr);
//			printf("%c  %-10s %5d %04x : %04x ",atc[attr],fname,filesize,addr,crs);

			fp = fopen(fname, "wb");	// o̓t@CI[v
			if (!filesize)				// 0bytẽt@C
			{
				fclose(fp);
				continue;
			}
			writesize = filesize;

			while (writesize > 0x400)
			{
//				printf ("%04x ",crs);
				fwrite(&buff[crs*0x400], 1, 0x400, fp);		// 1NX^
				writesize -= 0x400;
				if (ferror(fp)) {
					fprintf(stderr, "t@C߂܂. \n");
					return 1;
				}
				crs = fat[crs*2]+fat[crs*2+1]*0x100;		// FAT`FCH
			}

//			printf ("%04x\n",crs);
			fwrite(&buff[crs*0x400], 1, writesize, fp);		// `FC̍Ō
			if (ferror(fp)) { 
				fprintf(stderr, "t@C߂܂. \n");
				return 1;
			}

			fclose(fp);		// t@CN[Y
			if (ferror(fp)) { 
				fprintf(stderr, "t@C߂܂. \n");
				return 1;
			}
		}
		if (mode) _chdir("..");		// efBNg
	}
	return 0;
}
